import { Injectable } from '@nestjs/common';
import { DateTime, Interval } from 'luxon';
import { Structure } from '../structures/schemas/structure.schema';
import { PendingStructureDto } from './dto/pending-structure.dto';
import { UnclaimedStructureDto } from './dto/unclaimed-structure-dto';

@Injectable()
export class AdminService {
  public isDateOutdated(date: DateTime, nbMonths: number): boolean {
    const today = DateTime.local().setZone('utc', { keepLocalTime: true });
    return Interval.fromDateTimes(date, today).length('months') > nbMonths;
  }
  public getLastUpdateDate(structure: Structure | UnclaimedStructureDto | PendingStructureDto): DateTime {
    return structure.updatedAt ? structure.updatedAt : structure.createdAt;
  }
}
