import { Body, Controller, Get, Logger, Post } from '@nestjs/common';
import { ApiTags } from '@nestjs/swagger';
import { AppointmentDto } from './dto/appointment.dto';
import { IAppointment } from './interfaces/appointment.interface';

import { AppointmentService } from './appointment.service';

@ApiTags('appointment')
@Controller('appointment')
export class AppointmentController {
  private readonly logger = new Logger(AppointmentController.name);

  constructor(private appointmentService: AppointmentService) {}

  @Get()
  public findAll(): Promise<IAppointment[]> {
    this.logger.debug('findAll');
    return this.appointmentService.findAll();
  }

  @Post()
  public createAppointment(@Body() appointment: AppointmentDto): Promise<IAppointment> {
    this.logger.debug('create appointment');
    return this.appointmentService.create(appointment);
  }
}
