import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';
import { Document } from 'mongoose';

export type AppointmentDocument = Appointment & Document;

class StructureOrientator {
  structureName: string;
  structureMail: string;
  structurePhone: string;
}

@Schema({ timestamps: true })
export class Appointment {
  @Prop()
  name: string;

  @Prop()
  surname: string;

  @Prop()
  email: string;

  @Prop()
  phone: string;

  @Prop()
  onlineDemarcheType: string[];

  @Prop()
  structureOrientator: StructureOrientator;

  @Prop()
  structureRDV: string;

  @Prop()
  socialWorkerId: string;

  @Prop()
  details: string;
}

export const AppointmentSchema = SchemaFactory.createForClass(Appointment);
