import { HttpModule } from '@nestjs/axios';
import { HttpStatus } from '@nestjs/common';
import { Test, TestingModule } from '@nestjs/testing';
import { MailerMockService } from '../../test/mock/services/mailer.mock.service';
import { ConfigurationService } from '../configuration/configuration.service';
import { MailerModule } from '../mailer/mailer.module';
import { MailerService } from '../mailer/mailer.service';
import { ContactService } from './contact.service';
import { ContactMessage } from './schemas/contact-message.schema';

describe('ContactService', () => {
  let service: ContactService;

  beforeEach(async () => {
    const module: TestingModule = await Test.createTestingModule({
      imports: [HttpModule, MailerModule],
      providers: [ContactService, ConfigurationService, { provide: MailerService, useClass: MailerMockService }],
    }).compile();

    service = module.get<ContactService>(ContactService);
  });

  it('should be defined', () => {
    expect(service).toBeDefined();
  });

  it('should send message with status OK', async () => {
    const res = (await service.sendMessage(new ContactMessage())) as { data: { status: unknown } };
    expect(res.data.status).toBe(HttpStatus.OK);
  });
});
