import { Db } from 'mongodb';
import { getDb } from '../migrations-utils/db';

export const up = async () => {
  const db: Db = await getDb();

  const cursor = db.collection('categoriesformations').find({});
  let document;
  while ((document = await cursor.next())) {
    if (document.id == 'baseSkills') {
      const newDoc = {
        surname: 'ordinateur, smartphone, internet',
        name: 'Compétences de base',
      };
      await db.collection('categoriesformations').updateOne({ _id: document._id }, [{ $set: newDoc }]);
    } else if (document.id == 'accessRight') {
      const newDoc = {
        surname: 'Pôle emploi, CAF',
        name: 'Accès aux droits',
      };
      await db.collection('categoriesformations').updateOne({ _id: document._id }, [{ $set: newDoc }]);
    } else if (document.id == 'parentingHelp') {
      const newDoc = {
        surname: 'temps d’écran, scolarité',
        name: 'Aide à la parentalité',
      };
      await db.collection('categoriesformations').updateOne({ _id: document._id }, [{ $set: newDoc }]);
    } else if (document.id == 'socialAndProfessional') {
      const newDoc = {
        surname: 'CV, tableur',
        name: 'Insertion professionnelle',
      };
      await db.collection('categoriesformations').updateOne({ _id: document._id }, [{ $set: newDoc }]);
    } else if (document.id == 'digitalCultureSecurity') {
      const newDoc = {
        surname: 'réseaux sociaux, visio',
        name: 'Culture numérique',
      };
      await db.collection('categoriesformations').updateOne({ _id: document._id }, [{ $set: newDoc }]);
    }
  }
  console.log(`Update done`);
};

export const down = async () => {
  const db: Db = await getDb();

  const cursor = db.collection('categoriesformations').find({});
  let document;
  while ((document = await cursor.next())) {
    if (document.id == 'socialAndProfessional') {
      const newDoc = {
        surname: null,
        name: 'Insertion sociale et professionnelle',
      };
      await db.collection('categoriesformations').updateOne({ _id: document._id }, [{ $set: newDoc }]);
    } else if (document.id == 'baseSkills') {
      const newDoc = {
        surname: null,
        name: 'Les compétences de base',
      };
      await db.collection('categoriesformations').updateOne({ _id: document._id }, [{ $set: newDoc }]);
    } else if (document.id == 'parentingHelp') {
      const newDoc = {
        surname: null,
        name: 'Aide à la parentalité',
      };
      await db.collection('categoriesformations').updateOne({ _id: document._id }, [{ $set: newDoc }]);
    } else if (document.id == 'digitalCultureSecurity') {
      const newDoc = {
        surname: null,
        name: 'Culture et sécurité numérique',
      };
      await db.collection('categoriesformations').updateOne({ _id: document._id }, [{ $set: newDoc }]);
    } else if (document.id == 'accessRight') {
      const newDoc = {
        surname: null,
        name: 'Accès aux droits',
      };
      await db.collection('categoriesformations').updateOne({ _id: document._id }, [{ $set: newDoc }]);
    }
  }
  console.log(`Update done`);
};
