import { Db } from 'mongodb';
import { getDb } from '../migrations-utils/db';

export const up = async () => {
  const db: Db = await getDb();
  // Add employers
  await db.collection('employers').insertMany([
    { name: 'CAF', validated: true },
    { name: 'CARSAT', validated: true },
    { name: 'Pôle emploi', validated: true },
    { name: 'CPAM', validated: true },
    { name: 'Métropole de Lyon', validated: true },
    { name: 'Médiathèque / Bibliothèque', validated: true },
    { name: 'Mairie', validated: true },
    { name: 'CCAS', validated: true },
    { name: 'Centre socio-culturel', validated: true },
    { name: 'Association', validated: true },
    { name: `Structure d'insertion`, validated: true },
    { name: 'Structure de formation', validated: true },
    { name: 'Structure information jeunesse (SIJ)', validated: true },
    { name: 'Cyberbase', validated: true },
    { name: 'Fablab', validated: true },
    { name: 'Missions locales', validated: true },
    { name: 'MJC', validated: true },
    { name: 'Espace de coworking', validated: true },
    { name: 'Pimms', validated: true },
    { name: 'Ressourcerie', validated: true },
    { name: 'Maison France Service', validated: true },
  ]);

  // Add jobs
  await db.collection('jobs').insertMany([
    { name: 'CNFS', validated: true, hasPersonalOffer: true },
    { name: 'Médiateur numérique', validated: true, hasPersonalOffer: true },
    { name: 'Formateur', validated: true, hasPersonalOffer: true },
    { name: 'Travailleur social', validated: true, hasPersonalOffer: false },
    { name: 'Conseiller', validated: true, hasPersonalOffer: false },
    { name: 'Chef de projet', validated: true, hasPersonalOffer: false },
    { name: 'Élu', validated: true, hasPersonalOffer: false },
  ]);
};

export const down = async () => {
  const db: Db = await getDb();

  db.collection('employers').drop();
  db.collection('jobs').drop();
};
