import { Db } from 'mongodb';
import { getDb } from '../migrations-utils/db';

export const up = async () => {
  const db: Db = await getDb();

  await db
    .collection('categoriesaccompagnements')
    .updateOne(
      { id: 'proceduresAccompaniment', 'modules.id': 'accompagnantCaf' },
      { $set: { 'modules.$.text': 'CAF' } }
    );

  console.log(
    'Updated done: "Accompagnement CAF" to "CAF" from collection "categoriesAccompanements" with document id "proceduresAccompaniment"'
  );
};

export const down = async () => {
  const db: Db = await getDb();

  await db
    .collection('categoriesaccompagnements')
    .updateOne(
      { id: 'proceduresAccompaniment', 'modules.id': 'accompagnantCaf' },
      { $set: { 'modules.$.text': 'Accompagnement CAF' } }
    );

  console.log(
    'Downgraded "CAF" to "Accompagnement CAF" from collection "categoriesAccompanements" with document id "proceduresAccompaniment"'
  );
};
