import { Db } from 'mongodb';
import { getDb } from '../migrations-utils/db';

export const up = async () => {
  const db: Db = await getDb();
  const cursor = db.collection('structures').find({});
  let document;
  while ((document = await cursor.next())) {
    await db
      .collection('structures')
      .updateOne({ _id: document._id }, [{ $set: { freeWorkShop: document.freeWorkShop ? 'Oui' : 'Non' } }]);
  }
  console.log(`Update done : 'freeWorkshop' updated to string`);
};

export const down = async () => {
  const db: Db = await getDb();
  const cursor = db.collection('structures').find({});
  let document;
  while ((document = await cursor.next())) {
    await db
      .collection('structures')
      .updateOne({ _id: document._id }, [
        { $set: { freeWorkShop: ['Oui', 'Oui, sous condition'].includes(document.freeWorkShop) ? true : false } },
      ]);
  }
  console.log(`Revert done : 'freeWorkshop' updated to boolean`);
};
