import { Db } from 'mongodb';
import { getDb } from '../migrations-utils/db';

export const up = async () => {
  const db: Db = await getDb();
  await db
    .collection('jobsgroups')
    .insertMany([
      { name: 'Pilotage de projet' },
      { name: 'Coordination' },
      { name: 'Accompagnement numérique' },
      { name: 'Travail social' },
      { name: 'Direction' },
      { name: 'Insertion et emploi' },
    ]);

  console.log('Update done: collection jobsgroups created and populated');
};

export const down = async () => {
  const db: Db = await getDb();
  db.collection('jobsgroups').drop();

  console.log('Downgrade done: collection jobsgroups deleted');
};
