import { Db } from 'mongodb';
import { getDb } from '../migrations-utils/db';

export const up = async () => {
  const db: Db = await getDb();
  await db
    .collection('categories')
    .updateOne({ id: 'labelsQualifications' }, { $push: { modules: { id: 'mesPapiers', name: 'Mes Papiers' } } });
  console.log('Updated : "Mes papiers" added to "labelsQualifications" document in "categories" collection');
};

export const down = async () => {
  const db: Db = await getDb();
  await db
    .collection('categories')
    .updateOne({ id: 'labelsQualifications' }, { $pull: { modules: { id: 'mesPapiers', name: 'Mes Papiers' } } });
  console.log('Downgraded : "Mes papiers" removed from "labelsQualifications" document in "categories" collection');
};
