import { ApiProperty } from '@nestjs/swagger';
import { IsNotEmpty } from 'class-validator';

export class OnlineMediationDto {
  @IsNotEmpty()
  @ApiProperty({ type: String })
  readonly name: string;

  @IsNotEmpty()
  @ApiProperty({ type: String })
  surname: string;

  @IsNotEmpty()
  @ApiProperty({ type: String })
  readonly phone: string;

  @IsNotEmpty()
  readonly onlineDemarcheType: string[];

  @IsNotEmpty()
  readonly dateSlot: { day: string; hours: string };

  @IsNotEmpty()
  readonly preferredLanguage: string;
}
