import { HttpException, HttpStatus, Injectable } from '@nestjs/common';
import { InjectModel } from '@nestjs/mongoose';
import { Model } from 'mongoose';
import { IParameters } from './interface/parameters.interface';
import { Parameters } from './schemas/parameters.schema';

@Injectable()
export class ParametersService {
  constructor(@InjectModel(Parameters.name) private parametersModel: Model<IParameters>) {}

  public async getParameters(): Promise<Parameters> {
    const parameters = await this.parametersModel.findOne().exec();
    if (!parameters) {
      throw new HttpException('Parameters not found', HttpStatus.NOT_FOUND);
    }
    return parameters;
  }

  public async setParameterLockdownInfoDisplay(lockdownInfoDisplay: boolean): Promise<Parameters> {
    const parameters = await this.parametersModel.findOne().exec();
    if (!parameters) {
      throw new HttpException('Parameters not found', HttpStatus.NOT_FOUND);
    }
    parameters.lockdownInfoDisplay = lockdownInfoDisplay;
    await parameters.save();
    return parameters;
  }
}
