import { ApiProperty } from '@nestjs/swagger';
import { Type } from 'class-transformer';
import { IsNotEmpty, ValidateNested } from 'class-validator';
import { PersonalOfferDto } from './personal-offer.dto';

export class CreatePersonalOfferDto {
  @ApiProperty({
    description: 'Id of the structure',
    type: [String],
  })
  @IsNotEmpty()
  structureId: string;

  @ApiProperty({
    description: 'Personal offer to create',
    type: [String],
  })
  @ValidateNested({ each: true })
  @Type(() => PersonalOfferDto)
  personalOffer: PersonalOfferDto;
}
