import { SchemaFactory } from '@nestjs/mongoose';
import { IsNotEmpty } from 'class-validator';

export type AddressDocument = Address & Document;

export class Address {
  numero: string;

  @IsNotEmpty()
  street: string;

  @IsNotEmpty()
  commune: string;

  postcode: string;
  inseeCode: string;

  static equals = function (a: Address, b: Address) {
    // ignore inseeCode if not both set
    return (
      a.numero === b.numero &&
      a.street === b.street &&
      a.commune === b.commune &&
      (a.inseeCode && b.inseeCode ? a.inseeCode === b.inseeCode : true)
    );
  };
}

export const AddressSchema = SchemaFactory.createForClass(Address);
