import { Controller, Get, Param } from '@nestjs/common';
import { ApiTags } from '@nestjs/swagger';
import { StructureType, StructureTypeDocument } from './structure-type.schema';
import { StructureTypeService } from './structure-type.service';

@ApiTags('structures')
@Controller('structure-type')
export class StructureTypeController {
  constructor(private readonly structureTypeService: StructureTypeService) {}

  @Get()
  public async findAll(): Promise<StructureType[]> {
    return this.structureTypeService.findAll();
  }

  @Get(':id')
  public async find(@Param('id') id: string): Promise<StructureTypeDocument> {
    return this.structureTypeService.find(id);
  }
}
