import { Injectable } from '@nestjs/common';
import { InjectModel } from '@nestjs/mongoose';
import { Model } from 'mongoose';
import { StructureType, StructureTypeDocument } from './structure-type.schema';

@Injectable()
export class StructureTypeService {
  constructor(@InjectModel(StructureType.name) private structureTypeModel: Model<StructureTypeDocument>) {}

  public async findAll(): Promise<StructureType[]> {
    return this.structureTypeModel.find().exec();
  }

  public async find(id: string): Promise<StructureTypeDocument> {
    return this.structureTypeModel.findOne({ _id: id }).exec();
  }

  public async findByValue(value: string): Promise<StructureTypeDocument> {
    return this.structureTypeModel.findOne({ value: value }).exec();
  }
}
