import { IsBoolean, IsNotEmpty, IsOptional, IsString } from 'class-validator';
import { ApiProperty } from '@nestjs/swagger';
import { JobsGroupsDocument } from '../schemas/jobsGroups.schema';

export class CreateJobDto {
  @ApiProperty({ type: String, example: 'Developpeur' })
  @IsNotEmpty()
  @IsString()
  readonly name: string;

  @ApiProperty({ type: Boolean, example: false })
  @IsNotEmpty()
  @IsBoolean()
  readonly hasPersonalOffer: boolean;

  @ApiProperty({ required: false, example: { _id: 'id', name: 'Technique' } })
  @IsOptional()
  readonly jobsGroup: JobsGroupsDocument;
}
