import { Types } from 'mongoose';
import { IUser } from '../../../src/users/interfaces/user.interface';
import { IUserRegistry } from '../../../src/users/interfaces/userRegistry.interface';

export const usersMockData: IUser[] = [
  {
    structureOutdatedMailSent: [],
    pendingStructuresLink: ['6001a48e16b08100062e4180', '6093ba0e2ab5775cfc01fffe'],
    structuresLink: ['6093ba0e2ab5775cfc01fffe'],
    newEmail: null,
    changeEmailToken: null,
    role: 0,
    resetPasswordToken: null,
    validationToken:
      'b2b6caca1d38ca26d203b5f12b0d925df2928fab8ee7ccf9bbe78802ffa625f5abce825783bc62d0b11be5a90132cf5045a9a7776f01694c63b60bf64b0f680f',
    emailVerified: false,
    _id: '6036721022462b001334c4bb',
    email: 'a@a.com',
    name: 'Xavier',
    surname: 'NIEL',
    phone: '06 11 11 11 11',
    password: '$2a$12$vLQjJ9zAWyUwiXLeQDa6w.XzrlgPBhw.2GWrjog/yuEjIaZnQwmZu',
    personalOffers: [],
    __v: 1,
    save: jest.fn(),
  } as any,
  {
    structureOutdatedMailSent: [],
    pendingStructuresLink: ['6001a48e16b08100062e4180', '6093ba0e2ab5775cfc01fffe'],
    structuresLink: ['6093ba0e2ab5775cfc01fffe'],
    newEmail: null,
    changeEmailToken: null,
    role: 0,
    resetPasswordToken: null,
    validationToken:
      'b2b6caca1d38ca26d203b5f12b0d925df2928fab8ee7ccf9bbe78802ffa625f5abce825783bc62d0b11be5a90132cf5045a9a7776f01694c63b60bf64b0f680f',
    emailVerified: false,
    _id: '6036721022462b001334c4bb',
    email: 'a@a.com',
    name: 'Xavier',
    surname: 'NIEL',
    phone: '06 11 11 11 11',
    password: '$2a$12$vLQjJ9zAWyUwiXLeQDa6w.XzrlgPBhw.2GWrjog/yuEjIaZnQwmZu',
    personalOffers: [
      {
        _id: '1234ba0e2ab5775cfc01ed3e',
        proceduresAccompaniment: [],
        baseSkills: [],
        accessRight: [],
        digitalCultureSecurity: [],
        socialAndProfessional: [],
        parentingHelp: [],
        createdAt: 'Wed Mar 16 2022 14:29:11 GMT+0100 (heure normale d’Europe centrale)',
        updatedAt: 'Wed Mar 16 2022 17:29:11 GMT+0100 (heure normale d’Europe centrale)',
      },
    ],
    __v: 1,
    save: jest.fn(),
  } as any,
  {
    structureOutdatedMailSent: [],
    pendingStructuresLink: ['6001a48e16b08100062e4180', '6093ba0e2ab5775cfc01fffe'],
    structuresLink: [],
    newEmail: null,
    changeEmailToken: null,
    role: 0,
    resetPasswordToken: null,
    validationToken:
      'b2b6caca1d38ca26d203b5f12b0d925df2928fab8ee7ccf9bbe78802ffa625f5abce825783bc62d0b11be5a90132cf5045a9a7776f01694c63b60bf64b0f680f',
    emailVerified: false,
    _id: '6036721022462b001334c4bb',
    email: 'a@a.com',
    name: 'Xavier',
    surname: 'NIEL',
    phone: '06 11 11 11 11',
    password: '$2a$12$vLQjJ9zAWyUwiXLeQDa6w.XzrlgPBhw.2GWrjog/yuEjIaZnQwmZu',
    personalOffers: [],
    __v: 1,
    save: jest.fn(),
  } as any,
  {
    structureOutdatedMailSent: [],
    pendingStructuresLink: ['6001a48e16b08100062e4180', '6093ba0e2ab5775cfc01fffe'],
    structuresLink: ['6093ba0e2ab5775cfc01fffe', '6093ba0e2ab5775cfc01ffff', '6093ba0e2ab5775cfc020000'],
    newEmail: null,
    changeEmailToken: null,
    role: 0,
    resetPasswordToken: null,
    validationToken:
      'b2b6caca1d38ca26d203b5f12b0d925df2928fab8ee7ccf9bbe78802ffa625f5abce825783bc62d0b11be5a90132cf5045a9a7776f01694c63b60bf64b0f680f',
    emailVerified: false,
    _id: '6036721022462b001334c4bb',
    email: 'a@a.com',
    name: 'Xavier',
    surname: 'NIEL',
    phone: '06 11 11 11 11',
    password: '$2a$12$vLQjJ9zAWyUwiXLeQDa6w.XzrlgPBhw.2GWrjog/yuEjIaZnQwmZu',
    personalOffers: [],
    __v: 1,
    save: jest.fn(),
  } as any,
] as IUser[];

export const userDetails: IUser[] = [
  {
    _id: '627b85aea0466f0f132e1599',
    surname: 'ADMIN',
    name: 'Admin',
    email: 'admin@admin.com',
    employer: {
      name: 'CAF',
      validated: true,
    },
    job: {
      hasPersonalOffer: true,
      name: 'CNFS',
      validated: true,
    },
  },
] as IUser[];

export const multipleUsers: IUser[] = [
  {
    _id: '627b85aea0466f0f132e1599',
    surname: 'ADMIN',
    name: 'Admin',
    email: 'admin@admin.com',
    employer: {
      name: 'CAF',
      validated: true,
    },
    job: {
      hasPersonalOffer: true,
      name: 'CNFS',
      validated: true,
    },
  },
  {
    _id: '627b85aea0466f0f132e1598',
    surname: 'Guilhem',
    name: 'CARRON',
    email: 'admin@admin.com',
    employer: {
      name: 'Métropole',
      validated: true,
    },
    job: {
      hasPersonalOffer: true,
      name: 'CNFS',
      validated: true,
      jobsGroup: new Types.ObjectId('6442ad5a5b3fd128a5c0e3b4'),
    },
  },
  {
    _id: '627b85aea0466f0f132e1597',
    surname: 'Jean-Paul',
    name: 'DESCHAMPS',
    email: 'admin@admin.com',
    employer: {
      name: 'CAF',
      validated: true,
    },
    job: {
      hasPersonalOffer: true,
      name: 'Conseiller',
      validated: true,
    },
  },
  {
    _id: '627b85aea0466f0f132e1596',
    surname: 'Paula',
    name: 'Dubois',
    email: 'admin@admin.com',
    employer: {
      name: 'Pimms',
      validated: true,
    },
    job: {
      hasPersonalOffer: true,
      name: 'Conseiller',
      validated: true,
    },
  },
  {
    _id: '627b85aea0466f0f132e1595',
    surname: 'Marine',
    name: 'Ducal',
    email: 'admin@admin.com',
    employer: {
      name: 'Médiateur',
      validated: true,
    },
    job: {
      hasPersonalOffer: true,
      name: 'CNFS',
      validated: true,
    },
  },
  {
    _id: '627b85aea0466f0f132e1594',
    surname: 'Bastien',
    name: 'Dumont',
    email: 'admin@admin.com',
    employer: {
      name: 'Pimms',
      validated: true,
    },
    job: {
      hasPersonalOffer: true,
      name: 'CNFS',
      validated: true,
    },
  },
] as IUser[];

export const userRegistryMockData: IUserRegistry = {
  resetPasswordToken: null,
  _id: '6036721022462b001334c4bb',
  name: 'Xavier',
  surname: 'NIEL',
  __v: 1,
  save: jest.fn(),
} as any;
